import { LRParser } from '@lezer/lr';
import { LRLanguage, indentNodeProp, foldNodeProp, foldInside, LanguageSupport } from '@codemirror/language';
import { styleTags, tags } from '@lezer/highlight';

// This file was generated by lezer-generator. You probably shouldn't edit it.
const parser = LRParser.deserialize({
  version: 14,
  states: "!WQYQPOOOkQPO'#CeOOQO'#Cj'#CjOOQO'#Cf'#CfQYQPOOOOQO,59P,59POrQPO,59POOQO-E6d-E6dOOQO1G.k1G.k",
  stateData: "y~O]OSPOS~ORQOSQOTQOUQOWPO~OVTO~PYOVWO~PYO",
  goto: "v_PPPPPPPPP`fPPPpXQOPSUQSOQUPTVSUXROPSU",
  nodeNames: "⚠ LineComment Program String Boolean Number Operator ) ( Application",
  maxTerm: 14,
  nodeProps: [
    ["openedBy", 7,"("],
    ["closedBy", 8,")"]
  ],
  skippedNodes: [0,1],
  repeatNodeCount: 1,
  tokenData: "%U~RZXYtYZt]^tpqtrs!Vst#sxy$Ryz$W!Q![$]!]!^$e!c!}$|~yS]~XYtYZt]^tpqt~!YVOr!Vrs!os#O!V#O#P!t#P;'S!V;'S;=`#m<%lO!V~!tOR~~!wRO;'S!V;'S;=`#Q;=`O!V~#TWOr!Vrs!os#O!V#O#P!t#P;'S!V;'S;=`#m;=`<%l!V<%lO!V~#pP;=`<%l!V~#vQ#Y#Z#|#h#i#|~$ROS~~$WOW~~$]OV~~$bPT~!Q![$]~$jSP~OY$eZ;'S$e;'S;=`$v<%lO$e~$yP;=`<%l$e~%RPU~!c!}$|",
  tokenizers: [0],
  topRules: {"Program":[0,2]},
  tokenPrec: 0
});

const NuformulaLanguage = LRLanguage.define({
    parser: parser.configure({
        props: [
            indentNodeProp.add({
                Application: context => context.column(context.node.from) + context.unit
            }),
            foldNodeProp.add({
                Application: foldInside,
            }),
            styleTags({
                Boolean: tags.bool,
                String: tags.string,
                Number: tags.number,
                Operator: tags.operator,
                LineComment: tags.lineComment,
                "( )": tags.paren,
            }),
        ],
    }),
    languageData: {
        commentTokens: { line: ";" },
    },
});
function nuformula() {
    return new LanguageSupport(NuformulaLanguage);
}

export { NuformulaLanguage, nuformula };
